// src/router.ts
import u from "regexparam";
import {ServerRequest as R} from "worktop/request";
import {ServerResponse as m} from "worktop/response";

// src/internal/constants.ts
var c = {
  "400": "Bad Request",
  "401": "Unauthorized",
  "403": "Forbidden",
  "404": "Not Found",
  "405": "Method Not Allowed",
  "406": "Not Acceptable",
  "409": "Conflict",
  "410": "Gone",
  "411": "Length Required",
  "413": "Payload Too Large",
  "422": "Unprocessable Entity",
  "428": "Precondition Required",
  "429": "Too Many Requests",
  "500": "Internal Server Error",
  "501": "Not Implemented",
  "502": "Bad Gateway",
  "503": "Service Unavailable",
  "504": "Gateway Timeout"
};

// src/router.ts
function f(n) {
  return (a) => a.respondWith(n(a));
}
function y(n) {
  addEventListener("fetch", f(n));
}
async function l(n, a, o, ...r) {
  let e = await n(a, o, ...r);
  return e instanceof Response ? e : new Response(o.body, o);
}
function g() {
  let n, a = {};
  return n = {
    add(o, r, e) {
      let t = a[o];
      if (t === void 0 && (t = a[o] = {
        __d: new Map(),
        __s: {}
      }), r instanceof RegExp)
        t.__d.set(r, {keys: [], handler: e});
      else if (/[:|*]/.test(r)) {
        let {keys: s, pattern: i} = u(r);
        t.__d.set(i, {keys: s, handler: e});
      } else
        t.__s[r] = {keys: [], handler: e};
    },
    find(o, r) {
      let e = {}, t, s, i, d, p;
      if (s = a[o]) {
        if (t = s.__s[r])
          return {params: e, handler: t.handler};
        for ([i, d] of s.__d)
          if (p = i.exec(r), p !== null) {
            if (p.groups !== void 0)
              for (t in p.groups)
                e[t] = p.groups[t];
            else if (d.keys.length > 0)
              for (t = 0; t < d.keys.length; )
                e[d.keys[t++]] = p[t];
            return {params: e, handler: d.handler};
          }
      }
      return {params: e, handler: !1};
    },
    onerror(o, r, e, t) {
      let s = c[e = e || 500], i = t && t.message || s || String(e);
      return new Response(i, {status: e, statusText: s});
    },
    async run(o) {
      let r = new R(o), e = new m(r.method);
      if (n.prepare && await n.prepare(r, e), e.finished)
        return new Response(e.body, e);
      let {params: t, handler: s} = n.find(r.method, r.path);
      if (!s)
        return l(n.onerror, r, e, 404);
      try {
        return r.params = t, l(s, r, e);
      } catch (i) {
        return l(n.onerror, r, e, 500, i);
      }
    }
  };
}
export {
  g as Router,
  c as STATUS_CODES,
  y as listen,
  f as reply
};
